"use strict";
var file_version_assigner_1 = require('./file-version-assigner');
var path = require('path');
var FileNameParser = (function () {
    function FileNameParser() {
        var _this = this;
        this.parse = function (files) {
            var parsedFiles = [];
            for (var _i = 0, files_1 = files; _i < files_1.length; _i++) {
                var filePath = files_1[_i];
                var fileName = path.basename(filePath);
                var indexOfExtensionStart = fileName.lastIndexOf(".");
                var fileInfo = {
                    path: path.dirname(filePath),
                    fileName: fileName.substr(0, indexOfExtensionStart),
                    extension: fileName.substr(indexOfExtensionStart + 1, fileName.length - 1),
                    originalFileName: fileName,
                    versionedFileName: ''
                };
                fileInfo = _this.fileVersionAssigner.assignVersion(fileInfo);
                parsedFiles.push(fileInfo);
            }
            return parsedFiles;
        };
        this.fileVersionAssigner = new file_version_assigner_1.FileVersionAssigner();
    }
    return FileNameParser;
}());
exports.FileNameParser = FileNameParser;
//# sourceMappingURL=filename-parser.js.map