"use strict";
var file_retriever_1 = require('./file-retriever');
var FilesToUpdateRetriever = (function () {
    function FilesToUpdateRetriever() {
        var _this = this;
        this.retrieve = function () {
            return new Promise(function (fulfill, reject) {
                var files = [];
                _this.fileRetriever.retrieve('**/*.component.ts')
                    .then(function (componentFiles) {
                    files = files.concat(componentFiles);
                    return _this.fileRetriever.retrieve('**/*.html');
                })
                    .then(function (htmlFiles) {
                    files = files.concat(htmlFiles);
                    fulfill(files);
                });
            });
        };
        this.fileRetriever = new file_retriever_1.FileRetriever();
    }
    return FilesToUpdateRetriever;
}());
exports.FilesToUpdateRetriever = FilesToUpdateRetriever;
//# sourceMappingURL=files-to-update-retriever.js.map