"use strict";
var file_reader_1 = require('./file-reader');
var file_writer_1 = require('./file-writer');
var asset_name_replacer_1 = require('./asset-name-replacer');
var files_to_update_retriever_1 = require('./files-to-update-retriever');
var StringInstanceReplacer = (function () {
    function StringInstanceReplacer() {
        var _this = this;
        this.replaceInstances = function (files) {
            _this.filesToReplace = files;
            return new Promise(function (fulfill, reject) {
                _this.filesToUpdateRetriever.retrieve().then(function (assetReferencingFiles) {
                    var actions = assetReferencingFiles.map(_this.replaceInstance);
                    var results = Promise.all(actions);
                    results.then(function (data) {
                        console.log('updated files');
                        fulfill(data);
                    });
                });
            });
        };
        this.replaceInstance = function (fileToModify) {
            return new Promise(function (fulfill, reject) {
                _this.fileReader.readFile(fileToModify)
                    .then(function (fileContents) {
                    return _this.iterateFiles(fileContents);
                })
                    .then(function (fileContents) {
                    console.log("updating file " + fileToModify);
                    _this.fileWriter.write(fileToModify, fileContents).then(function () {
                        fulfill();
                    });
                });
            });
        };
        this.iterateFiles = function (fileContents) {
            console.log('iterating files');
            return new Promise(function (fulfill, reject) {
                for (var _i = 0, _a = _this.filesToReplace; _i < _a.length; _i++) {
                    var file = _a[_i];
                    fileContents = _this.assetNameReplacer.replace(fileContents, file.originalFileName, file.versionedFileName);
                }
                fulfill(fileContents);
            });
        };
        this.fileReader = new file_reader_1.FileReader();
        this.fileWriter = new file_writer_1.FileWriter();
        this.assetNameReplacer = new asset_name_replacer_1.AssetNameReplacer();
        this.filesToUpdateRetriever = new files_to_update_retriever_1.FilesToUpdateRetriever();
    }
    return StringInstanceReplacer;
}());
exports.StringInstanceReplacer = StringInstanceReplacer;
//# sourceMappingURL=string-instance-replacer.js.map