"use strict";
var file_retriever_1 = require('./file-retriever');
var filename_parser_1 = require('./filename-parser');
var file_renamer_1 = require('./file-renamer');
var string_instance_replacer_1 = require('./string-instance-replacer');
var Versioner = (function () {
    function Versioner() {
        var _this = this;
        this.version = function (fileSearch) {
            return new Promise(function (fulfill, reject) {
                _this.fileRetriever.retrieve(fileSearch)
                    .then(function (files) {
                    _this.parsedFiles = _this.fileNameParser.parse(files);
                    return _this.stringInstanceReplacer.replaceInstances(_this.parsedFiles);
                })
                    .then(function () {
                    var actions = _this.parsedFiles.map(_this.fileRenamer.rename);
                    var results = Promise.all(actions);
                    results.then(function (data) {
                        console.log(data);
                        fulfill(true);
                    });
                });
            });
        };
        this.fileRetriever = new file_retriever_1.FileRetriever();
        this.fileNameParser = new filename_parser_1.FileNameParser();
        this.fileRenamer = new file_renamer_1.FileRenamer();
        this.stringInstanceReplacer = new string_instance_replacer_1.StringInstanceReplacer();
    }
    return Versioner;
}());
exports.Versioner = Versioner;
//# sourceMappingURL=versioner.js.map